#!/bin/bash

source driver.sh
[[ ${CLEAN_LOG} -eq 1 ]] && rm -fR logs/*

export RUN_TIM=`date "+%Y%m%d%H%M%S"`
[[ ! -d logs/${RUN_TIM} ]] && mkdir -p logs/${RUN_TIM}

cp driver.sh ${DIR_LOGS}/${RUN_TIM}/driver_${RUN_TIM}.sh
export driver=${DIR_LOGS}/${RUN_TIM}/driver_${RUN_TIM}.sh

cd var_code

#-------------------------------------------------------------------------------------------------------- test certain scripts below
#--- plot figures
#for i in ${compare[*]};do
#    echo "export compare=${i}" >> ${driver}
#    echo "plotting for compare=${i}"
#    time ./plot.sh > ${DIR_LOGS}/${RUN_TIM}/compare${i}_${RUN_TIM}.log 2>&1
#done    
#exit
#--------------------------------------------------------------------------------------------------------- test over

##########################
#--- monthly Q(T,S)
echo "running trans_lat0_yearly_env.sh"
time ./trans_lat0_yearly_env.sh
########################## Basis of all other process, thus need make sure all models/runs done before using below scripts.


######################################
#--- XZ section of Q T S 
echo "running cat_time_QTS.sh"
time ./cat_time_QTS.sh
#--- catch Q(T,S ) files into one file
echo "cat_time_trans.sh"
time ./cat_time_trans.sh
###################################### Basis of below scripts.

###################################### 
#--- density: sigma2(T,S,2000db)
echo "running sig2_viv_eos10_cdo.sh"
time ./sig2_viv_eos10_cdo.sh
#--- Streamfunction @ LAT0: AMOC(sig2)
echo "running AMOC_qts_TBNS_from_yearly_cdo.sh"
time ./AMOC_qts_TBNS_from_yearly_cdo.sh
#--- AMOC(T)
echo "running AMOCT_qts_from_yearly_cdo.sh"
time ./AMOCT_qts_from_yearly_cdo.sh
#--- AMOC(S)
echo "running AMOCS_qts_from_yearly_cdo.sh"
time ./AMOCS_qts_from_yearly_cdo.sh
#--- Q(sig2), T(sig2), S(sig2)
echo "running QTSr_monthly.sh"
time ./QTSr_monthly.sh
###################################### 


################################################ need AMOC(sig2)
#--- Transport weighted T|S
echo "running trans_wgt_TS_yearly.sh"
time ./trans_wgt_TS_yearly.sh
#--- Meridional Heat Flux & FreshWater Transport
echo "running MHT_MFWT_qts_TBNS_from_yearly_cdo.sh"
time ./MHT_MFWT_qts_TBNS_from_yearly_cdo.sh

################################################ 
#--- plot figures
for i in ${compare[*]};do
    echo "export compare=${i}" >> ${driver}
    echo "plotting for compare=${i}"
    time ./plot.sh > ${DIR_LOGS}/${RUN_TIM}/compare${i}_${RUN_TIM}.log 2>&1
done    
