#!/bin/bash
alias rm=/bin/rm
name1=${0##*/}
name2=${name1%%.*}

source /${driver}
script="AMOC_qts_TBNS_from_yearly_cdo.ncl"

for exp   in ${exps[*]};do
for model in ${models[*]};do
for run   in ${runs[*]};do
for resol in ${resols[*]};do
for rmt   in 32 64;do

   export rmt=${rmt}
   export model=${model}

   export nc_sig="${DIR_REFS}/sigma2_on_theta-salt_plane_${resol}.nc"
   [[ ! -e ${nc_sig} ]] && continue

  export DIR_in0="${DIR_REFS}/"
  export DIR_in1="${DIR_DIAG}/${exp}/${model}/"
  export DIR_out="${DIR_DIAG}/${exp}/${model}/"

  for nc in `ls ${DIR_in1}/trans_${resol}_${model}_${run}_????-????_${LAT0}.nc`;do
      export nc_trans=${nc}
      yyyy=${nc##*_${run}_}
      yyyy=${yyyy%%_*}
      echo "==================== ${model} ${run} ${resol} ${rmt} ${yyyy} ${LAT0} ===================="
      export fout="${DIR_out}/AMOC${rmt}_${resol}_${model}_${run}_${yyyy}_${LAT0}.nc"
      [[ -e ${fout} ]] && continue
      echo ${fout}

      tim=`date "+%Y%m%d%H%M%S"`
      ncl="${DIR_LOGS}/${RUN_TIM}/${name2}_${model}_${run}_${resol}_${yyyy}_${rmt}_${LAT0}_${tim}.ncl"
      log="${DIR_LOGS}/${RUN_TIM}/${name2}_${model}_${run}_${resol}_${yyyy}_${rmt}_${LAT0}_${tim}.log"
      cp ${script} ${ncl}

if [[ ${use_node} -eq 1 ]];then
      exe="${DIR_LOGS}/${RUN_TIM}/${name2}_${model}_${run}_${resol}_${yyyy}_${rmt}_${LAT0}_${tim}.slurm"
      cp ${myjob}  ${exe}
      sed -i "s#./myjob.sh#ncl ${ncl}#g" ${exe}
      sed -i "s#17125823#${log%.log}#g" ${exe}
      sed -i "s#RUN_LOG#${log}#g" ${exe}
      sbatch ${exe}
      sleep 1
else
#------------------------------------------------------------------------------   
#--- CHESK LOAD: if load is low then submit, else if 
#--- load is high wait another 1 minute until load becomes low then submit 
    flag=0
    while [[ ${flag} -eq 0 ]];do   
        flag=0
        LOAD=`uptime|cut -d ',' -f4|awk '{print $3}'`
        echo "${LOAD} ${CPU}"
        if [[ `echo "${LOAD} < ${CPU}" | bc` -eq 1 ]]; then 
            flag=1
            echo "LOAD is low, submit job"
            nohup ncl -Q ${ncl} > ${log} 2>&1 &
            sleep 10
            LOAD=`uptime|cut -d ',' -f5`
        fi  
        [[ ${flag} -eq 0 ]] && read -t 2 -p "LOAD:${LOAD} > CPU:${CPU}" temp
    done
fi
  done
done
done
done
done
done
#\ps aux|grep fwang|grep ncl 
times
