load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_csm.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/shea_util.ncl"

lat0=stringtodouble(getenv("LAT0"))

if(tochar(getenv("figs_type")).eq."")then
   figs_type="png"
else
   figs_type=getenv("figs_type")
end if
;figs_type="png"
print(""+figs_type)

DIR_FIG=getenv("DIR_FIG")
wks   = gsn_open_wks(figs_type,DIR_FIG+"S_r_high_"+lat0+"_models_plot")
gsn_define_colormap(wks,"QTS")

;***************************************************************************************************************************
;              resource for public
;***************************************************************************************************************************
res = True

res@gsnFrame           = False   ; Don't advance the frame
res@gsnDraw            = False                 ; don't draw
res@vpHeightF          = 0.80    ; Width and height of
res@vpWidthF           = 0.8   ; each plot in NDC space.

res@gsnLeftString              = ""
res@gsnRightString             = ""
res@gsnCenterString            = ""

res@trXMinF = 32.0
res@trXMaxF = 37.3
res@trYMinF = 28.
res@trYMaxF = 37. 
res@trYReverse = True

res1=res
res1@xyMarkLineMode="Markers"
res1@xyMarker=1
res1@xyMarkerColor="red"
res1@xyMarkerSizeF=0.03

res2=res
res2@xyMarkLineMode="Markers"
res2@xyMarker=1
res2@xyMarkerColor="black"
res2@xyMarkerSizeF=0.03

res3=res
res3@xyMarkLineMode="Markers"
res3@xyMarker=1
res3@xyMarkerColor="black"
res3@xyMarkerSizeF=0.03

res@xyMarkLineMode = "Lines"                              ; Markers *and* lines
res@xyDashPattern  = 0
res@tiYAxisString        = "density ~F8~s~B~2~N~~F21~ (kg m~S~-3~N~)"
res@tiXAxisString        = "Temperature (~S~o~N~C)"

txres               = True                     ; text mods desired
txres@txFontThicknessF=2  
txres@txFontColor   = "black"
txres@txJust        = "CenterCenter"

plres = True
plres@gsLineColor = "black"
plres@gsLineDashPattern = 2
plres@gsLineThicknessF = 1 
x=(/0.,0./)
y=(/0.,6000./)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;txres@txFontColor   = "black"
txres@txFontColor   = "red"
txres@txJust        = "CenterCenter"

;***************************************************************************************************************************
;           resourse for upper plot
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
str=systemfunc("echo ${MODELS[*]}")
models=str_split(str, " ")   
str=systemfunc("echo ${MODELS_RUNS[*]}")
models_runs=str_split(str, " ")   
str=systemfunc("echo ${LEGENDS[*]}")
legends=str_split(str, " ")   
str=systemfunc("echo ${TEXTS[*]}")
texts=str_split(str, " ")

;print("models:"+models)
;print("models_runs:"+models_runs)
;print("legends:"+legends)
;printVarSummary(legends)

;***************************************************************************************************************************
;    data(n1,n2,n3): n1--number of lines in each plot(i), n2---the length of the line is, n3---number of plot(i)
;***************************************************************************************************************************

num_model=dimsizes(models)
col=tointeger(floor(sqrt(num_model)))
row=tointeger(ceil(num_model*1.0/col))

print(num_model+" "+row+" "+col)
txres@txFontHeightF = 0.06*1.1^(1-col)

  colors=(/"black","red"/)
  plot  = new(num_model,graphic)
  plot0 = new(num_model,graphic)
  plot1 = new(num_model,graphic)
  plots0= new(num_model,graphic)
  plots1= new(num_model,graphic)
  dum   = new(num_model,graphic)
  txt   = new(num_model,graphic)

DIR_in0    = getenv("DIR_REF")
nc0="QTSr32_high_hycom_R1_000101-000512_"+lat0+".nc"
nc1="QTSr64_high_hycom_R1_000101-000512_"+lat0+".nc"
;====================================================================================== Axis range
fin = addfile(DIR_in0+nc0,"r")
xxx0 = dim_avg_n_Wrap(fin->so(:,:,0,0),0)
yyy0 = tofloat(fin->lev)
XMin=min(xxx0)
YMin=min(yyy0)
XMax=max(xxx0)
YMax=max(yyy0)
delete(xxx0)
delete(yyy0)

do mm=0,num_model-1
  model=models(mm)
  DIR_in1    = getenv("DIR_DAT")+model+"/"
  ncs0=systemfunc("ls "+DIR_in1+"QTSr32_high_"+models_runs(mm)+"_????-????_"+lat0+".nc|head -n 1") 
  fin = addfile(ncs0,"r")
  xxx0 = dim_avg_n_Wrap(fin->so(:,:,0,0),0)
  yyy0 = tofloat(fin->lev)

  if(any(xxx0.gt.100))then
    xxx0=xxx0/1000.
  end if
  XMin=min((/XMin,min(xxx0)/))
  YMin=min((/YMin,min(yyy0)/))
  XMax=max((/XMax,max(xxx0)/))
  YMax=max((/YMax,max(yyy0)/))

  delete(xxx0)
  delete(yyy0)
end do
XMin=floor(XMin)
YMin=floor(YMin)
XMax= ceil(XMax)
YMax= ceil(YMax)
res@trXMinF = XMin
res@trYMinF = YMin
res@trXMaxF = XMax
res@trYMaxF = YMax
;============================================================
;============================================================

nc0="QTSr32_high_hycom_R1_000101-000512_"+lat0+".nc"
nc1="QTSr64_high_hycom_R1_000101-000512_"+lat0+".nc"
do mm=0,num_model-1
  model=models(mm)
  DIR_in1    = getenv("DIR_DAT")+model+"/"

  if(mod(mm,col).eq.0)then
    res@tmYLLabelsOn =True
    res@tiYAxisOn    =True
  else
    res@tmYLLabelsOn =False
    res@tiYAxisOn    =False
  end if
  
  if(mm/col.eq.row-1)then
    res@tmXBLabelsOn =True
    res@tiXAxisOn    =True
  else
    res@tmXBLabelsOn =False
    res@tiXAxisOn    =False
  end if

;------------------------------------------------------------------------------ hycom

  fin = addfile(DIR_in0+nc0,"r")
  xxx0 = dim_avg_n_Wrap(fin->so(:,:,0,0),0)
  yyy0 = tofloat(fin->lev)

  fin = addfile(DIR_in0+nc1,"r")
  xxx1 = dim_avg_n_Wrap(fin->so(:,:,0,0),0)
  yyy1 = tofloat(fin->lev)

  res@xyDashPattern    = 0
  res@xyLineColors     = "black"
  res@xyLineThicknessF = 1
  plot0(mm) = gsn_csm_xy(wks,xxx0,yyy0,res)
  res@xyDashPattern    = 1
  res@xyLineThicknessF = 1
  plot1(mm) = gsn_csm_xy(wks,xxx1,yyy1,res)
  delete(xxx0)
  delete(yyy0)
  delete(xxx1)
  delete(yyy1)

;------------------------------------------------------------------------------model
  ;;; ncs0=(/"QTSr32_high_ACCESS1-0_r1i1p1_185001-200512_"+lat0+".nc", \
  ncs0=systemfunc("ls "+DIR_in1+"QTSr32_high_"+models_runs(mm)+"_????-????_"+lat0+".nc|head -n 1")
  print(""+ncs0)
  fin = addfile(ncs0,"r")
  xxx0 = dim_avg_n_Wrap(fin->so(:,:,0,0),0)
  yyy0 = tofloat(fin->lev)

  if(any(xxx0.gt.100))then
    xxx0=xxx0/1000.
  end if

  res@xyDashPattern    = 0
  res@xyLineColors     = "red"
  res@xyLineThicknessF = 1
  plots0(mm) = gsn_csm_xy(wks,xxx0,yyy0,res)

  ncs1=systemfunc("ls "+DIR_in1+"QTSr64_high_"+models_runs(mm)+"_????-????_"+lat0+".nc|head -n 1")
  fin = addfile(ncs1,"r")
  xxx1 = dim_avg_n_Wrap(fin->so(:,:,0,0),0)
  yyy1 = tofloat(fin->lev)

  if(any(xxx0.gt.100))then
    xxx0=xxx0/1000.
  end if

  res@xyDashPattern    = 1
  res@xyLineThicknessF = 1
  plots1(mm) = gsn_csm_xy(wks,xxx1,yyy1,res)
  delete(xxx0)
  delete(yyy0)
  delete(xxx1)
  delete(yyy1)

  overlay(plot0(mm),plot1(mm))
  overlay(plot0(mm),plots0(mm))
  overlay(plot0(mm),plots1(mm))

  txt(mm) = gsn_add_text    (wks,plot0(mm),legends(mm),(res@trXMinF+res@trXMaxF)/2.,res@trYMinF+0.1*(res@trYMaxF-res@trYMinF),txres) 
  dum(mm) = gsn_add_polyline(wks, plot0(mm), x, y, plres)
end do

  res1                     = True
  res2                     = True
  res3                     = True
  res1@gsnMaximize         = True
  res2@gsnAttachPlotsYAxis = True
  res3@gsnAttachPlotsXAxis = True

if(num_model.gt.1)then
attachY=new((/row,max((/col-1,1/))/),"graphic")
do r=0,row-1
  ca=r*col+1
  cb=min((/num_model-1, (r+1)*col-1/))
  if(cb.lt.ca)then
     continue
  end if
  c0=ca-1
  print("r="+r+" c0="+c0+" ca="+ca+" cb="+cb)
  attachY(r,0:cb-ca) = gsn_attach_plots(plot0(c0),(/plot0(ca:cb)/),res1,res2)
end do

ids=ispan(0,num_model-1,col)
num_ids=dimsizes(ids)
attachX = gsn_attach_plots(plot0(0),(/plot0(ids(1:num_ids-1))/),res1,res3)

end if

;***************************************************************************************************************************
resP                            = True
;resP@gsnMaximize                = True
resP@gsnPaperOrientation        = "auto"    ;;; "portrait", "landscape", and "auto".
resP@wkPaperHeightF             = 11.0
resP@wkPaperWidthF              = 11.0
gsn_panel(wks,plot0(0),(/1,1/),resP)

fig=DIR_FIG+"S_r_high_"+lat0+"_models_plot."+figs_type
cmd = "convert -trim +repage -border 8 -bordercolor white -background white -flatten "+fig+" "+fig
; system(cmd)
