#!/bin/bash
alias rm=/bin/rm
name1=${0##*/}
name2=${name1%%.*}

source /${driver}


for exp   in ${exps[*]};do
for model in ${models[*]};do
for run   in ${runs[*]};do
   DIR_in0="${DIR_DIAG}/${exp}/${model}/annual"
   DIR_out="${DIR_DIAG}/${exp}/${model}"
   echo "==================== ${model} ${run} ===================="
   num=`ls ${DIR_in0}/QTS_${model}_${run}_????_*_${LAT0}.nc|wc -l`
   [[ ${num} -eq 0 ]] && continue

   nc=`ls ${DIR_in0}/QTS_${model}_${run}_????_*_${LAT0}.nc|head -n 1`
   yyyy0=${nc##*_${run}_}
   yyyy0=${yyyy0%%_*}
   nc=`ls ${DIR_in0}/QTS_${model}_${run}_????_*_${LAT0}.nc|tail -n 1`
   yyyy1=${nc##*_${run}_}
   yyyy1=${yyyy1%%_*}
   fout=${DIR_out}/QTS_${model}_${run}_${yyyy0}-${yyyy1}_${LAT0}.nc
   echo ${fout}
   tim=`date "+%Y%m%d%H%M%S"`
   log="${DIR_LOGS}/${RUN_TIM}/${name2}_${exp}_${model}_${run}_${LAT0}_${tim}.log"
   ls ${DIR_in0}/QTS_${model}_${run}_????_*_${LAT0}.nc >${log}
   echo "----------------------------------------------------------------------------------------------------" >>${log} 
   echo ${fout} >>${log}
   echo "----------------------------------------------------------------------------------------------------" >>${log} 
   [[ ! -e ${fout} ]] && cdo cat ${DIR_in0}/QTS_${model}_${run}_????_*_${LAT0}.nc ${fout} >> ${log} 2>&1
#   cdo cat ${DIR_in0}/QTS_${model}_r1i1p1_????_*_${LAT0}.nc ${fout}
done
done
done
