load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_csm.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/shea_util.ncl"

lat0=stringtodouble(getenv("LAT0"))
rmt=32
;lon0=-98
;lon1=-15
lon0=stringtodouble(getenv("LON_WEST"))
lon1=stringtodouble(getenv("LON_EAST"))
if(tochar(getenv("LEV_BOT")).eq."")then
   lev1=5400
else
   lev1=stringtodouble(getenv("LEV_BOT"))
end if

if(lon0.gt.180)then
   lon0=lon0-360
end if   
if(lon1.gt.180)then
   lon1=lon1-360
end if

DIR_out="./"

if(tochar(getenv("figs_type")).eq."")then
   figs_type="png"
else
   figs_type=getenv("figs_type")
end if
;figs_type="png"
print(""+figs_type)

DIR_FIG=getenv("DIR_FIG")
wks   = gsn_open_wks(figs_type,DIR_FIG+"sig2_"+lat0+"_climate_xz_plot")
gsn_define_colormap(wks,"ncl_default")

;***************************************************************************************************************************
res                            = True
res@cnFillOn                   = True
res@cnLinesOn                  = False
res@cnLineLabelsOn             = False
res@cnLabelMasking             = False
res@cnMissingValPerimOn        = False
res@cnMissingValFillColor      = "grey"
res@cnInfoLabelOn               = False
res@cnLevelSelectionMode        = "ExplicitLevels"

res@gsnFrame                   = False
res@gsnDraw                    = False
res@gsnSpreadColors            = True
res@gsnSpreadColorEnd          = -3
res@gsnXAxisIrregular2Linear   = True
res@gsnLeftString              = ""
res@gsnRightString             = ""
res@gsnCenterString            = ""
res@gsnContourZeroLineThicknessF = 1.45                 ; Thick the zero line: Default: 1.0 
res@gsnContourNegLineDashPattern = 1                 ; set the Negtive lines' dash pattern Default: 0 (solid line)

res@lbLabelBarOn               = False

;res@tiYAxisFontHeightF          = 0.025    ; Default: 0.025
;res@tiXAxisFontHeightF          = 0.025    ; Default: 0.025

;res@tmXBLabelFontHeightF        = 0.02     ; Default: <dynamic> -- initially 0.02 for a viewport width of 0.6
;res@tmYLLabelFontHeightF        = 0.02     ; Default: <dynamic> -- initially 0.02 for a viewport width of 0.6

res@trYReverse                  = True
res@tiMainString          = ""
res@tiYAxisString         = ""
res@tiXAxisString         = ""

res@tmYROn                = False
res@tmYLOn                = True 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
res0                       = res

res0@tmYLMode              = "Explicit"
res0@tmYLMinorOn           = True
res0@tmXBLabelsOn          = False
res0@tmXBOn                = True 
res0@tmXTOn                = False

res0@cnFillMode           = "CellFill"
res0@cnFillOn             = True
res0@cnLevelSelectionMode = "ExplicitLevels"
res0@cnLineLabelsOn       = False
res0@cnLinesOn            = False

values=ispan(0,6000,1000)
res0@gsnYAxisIrregular2Linear = True 
res0@tmYLMode                 = "Explicit"
res0@tmYLValues               = values
res0@tmYLMinorValues          = ispan(0,6000,200)
res0@tmYLLabels=(/"0", "1000", "2000", "3000", "4000", "5000", "6000"/)
res0@trYMinF = 0.
res0@trYMaxF = lev1
res0@trXMinF = lon0
res0@trXMaxF = lon1
;res0@cnFillMode           = "CellFill"

res0@gsnXAxisIrregular2Linear = True 
res0@tmXBMode                 = "Explicit"
res0@tmXBValues               = ispan(-80,20,20)
res0@tmXBMinorValues          = ispan(-90,20,5)
res0@tmXBLabels=(/"80W", "60W", "40W", "20W", "0", "20E"/)

;res0@tmXBLabelsOn=True
;res0@tiXAxisString        = "Longitude"
;res0@tmYLLabelsOn=True
;res0@tiYAxisString        = "Depth (m)"

res1 = res0
res1@cnFillOn           = False
res1@cnLinesOn          = True

res1@cnInfoLabelOn            = False

res1@cnLineLabelPlacementMode = "Computed"            
res1@cnLineLabelsOn           = True
res1@cnLineLabelBackgroundColor = -1
res1@cnLineLabelFontColor     = "black"
;res1@cnLineLabelFontHeightF   = 0.018                 ; Default: <dynamic> -- 0.012 for a viewport width of 0.6
res1@cnLineLabelFontThicknessF= 1.0                   ; Default: Default: 1.0
res1@cnLineLabelAngleF        = 0.
res1@cnLineLabelInterval      = 1                     ; default = 2

;res1@cnLineDashSegLenF       = 0.25                   ; Default: 0.15 (for a viewport width of 0.6)
res1@cnLineLabelDensityF      = 0.2                   ; Default: 0.0
;res1@cnLineLabelDensityF      = 0.0                   ; Default: 0.0
;res1@cnLineThicknessF         = 1.0                  ; Default: 1.0

txres               = True                     ; text mods desired
txres@txFontThicknessF = 2
txres@txFontColor   = "black"
;txres@txFontColor   = "red"
txres@txJust        = "CenterCenter"

;***************************************************************************************************************************
;           resourse for upper plot
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
str=systemfunc("echo ${MODELS[*]}")
models=str_split(str, " ")   
str=systemfunc("echo ${MODELS_RUNS[*]}")
models_runs=str_split(str, " ")   
str=systemfunc("echo ${LEGENDS[*]}")
legends=str_split(str, " ")   
str=systemfunc("echo ${TEXTS[*]}")
texts=str_split(str, " ")

;print("models:"+models)
;print("models_runs:"+models_runs)
;print("legends:"+legends)
;printVarSummary(legends)

;======================================================================
; qq(k,i,m,g)
; k ---> Upper, Middle, Lower
; i ---> All, Pos, Neg
; m ---> model
;======================================================================
;***************************************************************************************************************************
;    data(n1,n2,n3): n1--number of lines in each plot(i), n2---the length of the line is, n3---number of plot(i)
;***************************************************************************************************************************

num_model=dimsizes(models)

col=tointeger(floor(sqrt(num_model)))
row=tointeger(ceil(num_model*1.0/col))

print(" "+row+" "+col)

txres@txFontHeightF = 0.04*1.1^(1-col)

plot0 = new((/num_model/),graphic)
plot1 = new((/num_model/),graphic)
txt   = new((/num_model/),graphic)

nn=0
;------------------------------------------------------------------------------Contour levels
do mm=0,num_model-1
  model=models(mm)
;  print(nn+" "+mm+" "+model)
  DIR_in1    = getenv("DIR_DAT")+model+"/"
  ncs0=systemfunc("ls "+DIR_in1+"QTS_"+models_runs(mm)+"_????-????_"+lat0+".nc|head -n 1")
  print("LOADING... "+ncs0)
  fin = addfile(ncs0,"r")
  vmo = dim_avg_n_Wrap(fin->vmo,0)

  ncs0=systemfunc("ls "+DIR_in1+"sig2_"+models_runs(mm)+"_????-????_"+lat0+".nc|head -n 1")
  print("LOADING... "+ncs0)
  fin = addfile(ncs0,"r")
  sig2 = dim_avg_n_Wrap(fin->sig2,0)

  sig2@_FillValue = 1e20
  sig2 = where(ismissing(vmo),sig2@_FillValue,sig2)
  delete(vmo)
  if(max(sig2).gt.1000.)then
     sig2=sig2-1000.
  end if
  if(mm.eq.0)then
     min0=min(sig2)
     max0=max(sig2)
  else
     min0=min( (/min(sig2),min0/) )
     max0=max( (/max(sig2),max0/) )
  end if
  delete(sig2)
  print(nn+" "+mm+" "+min0+" "+max0+" "+model)
end do  

if(num_model.gt.25)then
   levels=round(log(fspan(exp(min0),exp(max0),10))*100.,3)/100.
else 
   levels=round(log(fspan(exp(min0),exp(max0),20))*100.,3)/100.
end if 
 print(""+levels)
;------------------------------------------------------------------------------model
nn=0
do mm=0,num_model-1
  model=models(mm)
;  print(nn+" "+mm+" "+model)
  DIR_in1    = getenv("DIR_DAT")+model+"/"
  ncs0=systemfunc("ls "+DIR_in1+"QTS_"+models_runs(mm)+"_????-????_"+lat0+".nc|head -n 1")
  print("LOADING... "+ncs0)
  fin = addfile(ncs0,"r")
  vmo = dim_avg_n_Wrap(fin->vmo,0)

  ncs0=systemfunc("ls "+DIR_in1+"sig2_"+models_runs(mm)+"_????-????_"+lat0+".nc|head -n 1")
  print("LOADING... "+ncs0)
  fin = addfile(ncs0,"r")
  sig2 = dim_avg_n_Wrap(fin->sig2,0)

  sig2@_FillValue = 1e20
  sig2 = where(ismissing(vmo),sig2@_FillValue,sig2)
  delete(vmo)

  if(max(sig2).gt.1000.)then
     sig2=sig2-1000.
  end if

  lev = fin->lev
  lon = fin->lon
  lon = where(lon.gt.180,lon-360,lon) 
  lon = where(lon.lt.-180,lon+360,lon) 
  if(max(abs(lev)).gt.1e4)then
     lev=lev/100.
  end if

  lon@long_name = "longitude"
  lon@units     = "degrees_east"
  sig2&lon=tofloat(lon)

  ncs1=systemfunc("ls "+DIR_in1+"AMOC"+rmt+"_high_"+models_runs(mm)+"_????-????_"+lat0+".nc|head -n 1")
  print("LOADING... "+ncs1)
  fin = addfile(ncs1,"r")
  sig_max = dim_avg_n_Wrap(fin->sig_max(:,0),0)
  sig_000 = dim_avg_n_Wrap(fin->sig_000(:,0),0)

if(lev(0).gt.lev(1))then
   lev=lev(::-1)
   sig2=sig2(::-1,:)
end if     
  num_lon=dimsizes(sig2(0,:))
  num_lev=dimsizes(sig2(:,0))
  ii0=minind(abs(lon0-lon))
  ii1=minind(abs(lon1-lon))

  if(ii1.lt.ii0)then
;    print("Pacific Centered")
    numx=(num_lon-1-ii0+1)+(ii1)+1
    tmp=new((/num_lev,numx/),"double",1e20)
    sig=new((/num_lev,numx/),"double",1e20)
    tmp(:,0:num_lon-ii0-1)=(/sig2(:,ii0:num_lon-1)/)
    sig(:,0:num_lon-ii0-1)=(/  sig2(:,ii0:num_lon-1)/)
    tmp(:,num_lon-ii0:numx-1)=(/sig2(:,0:ii1)/)
    sig(:,num_lon-ii0:numx-1)=(/  sig2(:,0:ii1)/)
    xxx=new(numx,"double",1e20)
    xxx(0:num_lon-ii0-1)=lon(ii0:num_lon-1)
    xxx(num_lon-ii0:numx-1)=lon(0:ii1)
    tmp!0="lev"
    tmp!1="lon"
    tmp&lev=lev
    tmp&lon=xxx
    sig!0="lev"
    sig!1="lon"
    sig&lev=lev
    sig&lon=xxx
  else
;    print("Atlantic Centered")
    numx=ii1-ii0+1
    tmp=new((/num_lev,numx/),"double",1e20)
    sig=new((/num_lev,numx/),"double",1e20)
    tmp(:,0:numx-1)=(/sig2(:,ii0:ii1)/)
    sig(:,0:numx-1)=(/  sig2(:,ii0:ii1)/)
    xxx=new(numx,"double",1e20)
    xxx(0:numx-1)=lon(ii0:ii1)
    tmp!0="lev"
    tmp!1="lon"
    tmp&lev=lev
    tmp&lon=xxx
    sig!0="lev"
    sig!1="lon"
    sig&lev=lev
    sig&lon=xxx
  end if
  delete(xxx)

  if(mod(nn,col).eq.0)then
    res0@tmYLLabelsOn =True
    res0@tiYAxisOn    =True
  else
    res0@tmYLLabelsOn =False
    res0@tiYAxisOn    =False
  end if

  if(nn/col.eq.row-1)then
    res0@tmXBLabelsOn =True
    res0@tiXAxisOn    =True
  else
    res0@tmXBLabelsOn =False
    res0@tiXAxisOn    =False
  end if

if(nn.eq.0)then
;  printVarSummary(sig2)
;  printVarSummary(tmp)
;  printVarSummary(sig)
  res0@cnLevels     = levels
;  print(""+res0@cnLevels)
end if  
  plot0(nn) = gsn_csm_contour(wks,tmp,res0)
  res1@cnLevels     = (/sig_max,sig_000/)
  plot1(nn) = gsn_csm_contour(wks,sig,res1)
;  txt(nn)   = gsn_add_text   (wks,plot0(nn),texts(mm),(res0@trXMinF+res0@trXMaxF)/2.,res0@trYMinF+0.9*(res0@trYMaxF-res0@trYMinF),txres)
  txt(nn)   = gsn_add_text   (wks,plot0(nn),legends(mm),(res0@trXMinF+res0@trXMaxF)/2.,res0@trYMinF+0.9*(res0@trYMaxF-res0@trYMinF),txres)
  overlay(plot0(nn),plot1(nn))

  delete(sig2)
  delete(tmp)
  delete(sig)
  delete(lon)
  delete(lev)

  nn=nn+1
end do ;;; model loop

  res1                     = True
  res2                     = True
  res3                     = True
  res1@gsnMaximize         = True
  res2@gsnAttachPlotsYAxis = True
  res3@gsnAttachPlotsXAxis = True

if(num_model.gt.1)then
attachY=new((/row,max((/col-1,1/))/),"graphic")
do r=0,row-1
  ca=r*col+1
  cb=min((/num_model-1, (r+1)*col-1/))
  if(cb.lt.ca)then
     continue
  end if
  c0=ca-1
  print("r="+r+" c0="+c0+" ca="+ca+" cb="+cb)
  attachY(r,0:cb-ca) = gsn_attach_plots(plot0(c0),(/plot0(ca:cb)/),res1,res2)
end do

ids=ispan(0,num_model-1,col)
num_ids=dimsizes(ids)
attachX = gsn_attach_plots(plot0(0),(/plot0(ids(1:num_ids-1))/),res1,res3)

end if

;***************************************************************************************************************************
resP                            = True
if(num_model.eq.1)then
   resP@gsnMaximize                = False
else
   resP@gsnMaximize                = True
end if
resP@gsnPanelLabelBar           = True
;if(row.gt.col)then
;   resP@lbOrientation               = "Vertical"     ; vertical label bar 
;   resP@pmLabelBarWidthF           = 0.04
;else
   resP@lbOrientation               = "Horizontal"   ; vertical label bar 
   resP@pmLabelBarHeightF          = 0.03
;end if
resP@lbLabelAutoStride          = True
resP@lbLabelFontHeightF         =0.012*1.2^(1-col)
;resP@pmLabelBarOrthogonalPosF   = -0.02
;resP@pmLabelBarParallelPosF     = -0.05
;resP@gsnPanelRowSpec = True
;resP@gsnPanelCenter = False
resP@gsnPaperOrientation        = "auto"
gsn_panel(wks,plot0(0),(/1,1/),resP)

fig=DIR_FIG+"sig2_"+lat0+"_climate_xz_plot."+figs_type
cmd = "convert -trim +repage -border 8 -bordercolor white -background white -flatten "+fig+" "+fig
; system(cmd)
