load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_csm.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/shea_util.ncl"

begTime = get_cpu_time()

;---------------------------------------------------------------------
        a0  =  9.9984085444849347e+02
        a1  =  7.3471625860981584e+00
        a2  = -5.3211231792841769e-02
        a3  =  3.6492439109814549e-04
        a4  =  2.5880571023991390e+00
        a5  = -6.7168282786692355e-03
        a6  =  1.9203202055760151e-03
        a7  =  1.1798263740430364e-02
        a8  =  9.8920219266399117e-08
        a9  =  4.6996642771754730e-06
        a10 = -2.5862187075154352e-08
        a11 = -3.2921414007960662e-12

        b0  =  1.0000000000000000e+00
        b1  =  7.2815210113327091e-03
        b2  = -4.4787265461983921e-05
        b3  =  3.3851002965802430e-07
        b4  =  1.3651202389758572e-10
        b5  =  1.7632126669040377e-03
        b6  = -8.8066583251206474e-06
        b7  = -1.8832689434804897e-10
        b8  =  5.7463776745432097e-06
        b9  =  1.4716275472242334e-09
        b10 =  6.7103246285651894e-06
        b11 = -2.4461698007024582e-17
        b12 = -9.1534417604289062e-18
;---------------------------- DIR & ncs ------------------------------
lat0=stringtodouble(getenv("LAT0"))

DIR_in0    = getenv("DIR_in0")
DIR_out    = getenv("DIR_out")
yymm       = getenv("yymm")

setfileoption("nc","Format","LargeFile") 

;;; QTS_BCC-CSM2-MR_r1i1p1_1850-2014_26.5.nc
ncs0 = getenv("ncs0")

fin0 = addfile(DIR_in0+ncs0,"r")
;---------------------------------------------------------------------
fNames = getfilevarnames(fin0)
numf=dimsizes(fNames)

;print(""+fNames)

;print("==============================")
var=fin0->thetao(0:1,0:1,0:1)
vNames=getVarDimNames(var)
delete(var)

numv=dimsizes(vNames)
;print(""+vNames)

;print("==============================")
nums=numf-numv-1
Names=fNames
Names=""
n=0
do v=0,numf-1
   if(all( vNames.ne.fNames(v)) .and. fNames(v).ne."thetao" .and. fNames(v).ne."so" .and. fNames(v).ne."vmo")then
      Names(n)=fNames(v)
      n=n+1
   end if
end do   

num_tim=dimsizes(fin0->time)

tim = fin0->time(0:num_tim-1)

  t  = fin0->thetao
  s  = fin0->so

;print("--------------- Read Data OK ---------------")

if(max(t(0,:,:)).gt.100) then
  t = t - 273.15
end if

if(max(s(0,:,:)).lt.1) then
  s = s * 1000.
end if

p=2000.
     t2  = t*t
     sp5 = sqrt(s)
     pt = p*t

num0=t
den0=t
sig2=t
num0=1e20
den0=1e20
sig2=1e20

epsln=1e-20

num0 = a0 + t*(a1 + t*(a2+a3*t) ) \
          + s*(a4 + a5*t  + a6*s) \
          + p*(a7 + a8*t2 + a9*s + p*(a10+a11*t2))

den0 = b0 + t*(b1 + t*(b2 + t*(b3 + t*b4)))       \
          + s*(b5 + t*(b6 + b7*t2) + sp5*(b8 + b9*t2)) \
          + p*(b10 + pt*(b11*t2 + b12*p))

sig2 = num0/(epsln+den0)
sig2@_FillValue=1e20
replace_ieeenan (sig2, sig2@_FillValue, 0)
sig2=where(sig2.gt.1100, sig2@_FillValue, sig2)
printMinMax(sig2,False)
print("Density compute OK: " + (get_cpu_time() - begTime))

sig2@long_name="potential density"
sig2@units="kg/m^3"
sig2&time=tim
;printVarSummary(sig2)
;---------------------------------------------------------------------
nco0 = getenv("nco0")
  system("rm "+DIR_out+nco0)
fout = addfile(DIR_out+nco0,"c")
;=============================================================================
do n=0,nums-1
   if(Names(n).eq."")then
      continue
   end if
   print(""+Names(n))
   fout->$Names(n)$ = fin0->$Names(n)$
end do
fout->sig2 = sig2

delete(fout)
;============================================================================= yearly
print("----------------------------------------------------------------------------------------------------: yearly")
num_time=dimsizes(tim)
num_year=max((/num_time/12,1/))

tmp=sig2(0:num_year-1,:,:)
tim0=tim(0:num_year-1)
do y=0,num_year-1
   ta=y*12
   tb=(y+1)*12-1
   tb=min((/tb,num_time-1/))
   tim0(y)=(/avg(tim(ta:tb))/)
;   tmp(y,:,:) =(/dim_sum_n_Wrap(sig2(ta:tb,:,:),0)/(tb-ta+1)/)
   tmp(y,:,:) =dim_avg_n_Wrap(sig2(ta:tb,:,:),0)
end do
tmp&time = tim0
;printVarSummary(tmp)
printMinMax(tmp,False)

nco1 = getenv("nco1")
  system("rm "+DIR_out+nco1)
fout = addfile(DIR_out+nco1,"c")
fout->sig2  = tmp
do n=0,nums-1
   if(Names(n).eq."")then
      continue
   end if
   print(""+Names(n))
   fout->$Names(n)$ = fin0->$Names(n)$
end do

print(""+yymm)
print("Plot generation time: " + (get_cpu_time() - begTime))
