#!/bin/bash
alias rm=/bin/rm
name1=${0##*/}
name2=${name1%%.*}

source /${driver}

#slurm="myjob.slurm"
script="sig2_viv_eos10_cdo.ncl"

for exp   in ${exps[*]};do
for model in ${models[*]};do
for run   in ${runs[*]};do
   export DIR_in0="${DIR_DIAG}/${exp}/${model}/"
   export DIR_out="${DIR_DIAG}/${exp}/${model}/"

for nc in `ls ${DIR_in0}/QTS_${model}_${run}_????-????_${LAT0}.nc`;do
  yyyy=${nc##*_${run}_}
  yyyy=${yyyy%%_*}
  export yymm="${yyyy:0:4}01-${yyyy:5:4}12"

  echo "==================== ${model} ${run} ${yymm} ${LAT0} ===================="

  fout="${DIR_out}/sig2_${model}_${run}_${yymm}_${LAT0}.nc"
  [[ -e ${fout} ]] && continue
  echo ${fout}
  fout1="${DIR_out}/sig2_${model}_${run}_${yyyy}_${LAT0}.nc"

  tim=`date "+%Y%m%d%H%M%S"`
  ncl="${DIR_LOGS}/${RUN_TIM}/${name2}_${model}_${run}_${LAT0}_${yymm}_${tim}.ncl"
  log="${DIR_LOGS}/${RUN_TIM}/${name2}_${model}_${run}_${LAT0}_${yymm}_${tim}.log"
  cp ${script} ${ncl}

  export ncs0=${nc##*/}
  export nco0=${fout##*/}
  export nco1=${fout1##*/}
  echo "ncs0: ${ncs0}"
  echo "nco0: ${nco0}"
  echo "nco1: ${nco1}"

if [[ ${use_node} -eq 1 ]];then
  exe="${DIR_LOGS}/${RUN_TIM}/${name2}_${model}_${run}_${LAT0}_${yymm}_${tim}.slurm"
  cp ${myjob}  ${exe}
  sed -i "s#./myjob.sh#ncl ${ncl}#g" ${exe}
  sed -i "s#17125823#${log%.log}#g" ${exe}
  sed -i "s#RUN_LOG#${log}#g" ${exe}
  sbatch ${exe}
  sleep 1
else
#------------------------------------------------------------------------------   
#--- CHESK LOAD: if load is low then submit, else if 
#--- load is high wait another 1 minute until load becomes low then submit 
    flag=0
    while [[ ${flag} -eq 0 ]];do   
        flag=0
        LOAD=`uptime|cut -d ',' -f4|awk '{print $3}'`
        echo "${LOAD} ${CPU}"
        if [[ `echo "${LOAD} < ${CPU}" | bc` -eq 1 ]]; then 
            flag=1
            echo "LOAD is low, submit job"
            nohup ncl -Q ${ncl} > ${log} 2>&1 &
            sleep 10
            LOAD=`uptime|cut -d ',' -f5`
        fi  
        [[ ${flag} -eq 0 ]] && read -t 1 -p "LOAD:${LOAD} > CPU:${CPU}" temp
    done
fi

done ### nc loop
done ### run loop
done ### model loop
done ### exp loop
times
