;----------------------------------------------------------------------------------------------------
;--- levels = [ min, max ] : however, very few points around min/max, most points close to 0
;--- Thus, a thought is to split evenly by points number, each bin has similar number of points.
;----------------------------------------------------------------------------------------------------
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_csm.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/shea_util.ncl"

lat0=stringtodouble(getenv("LAT0"))
rmt=32

sigs=(/30.1, 30.3, 30.5, 30.7, 30.9, 31.1, 31.3, 31.5, 31.7, 31.9, 32.1, 32.3, 32.5, 32.7, 32.9, 33.1, 33.3, 33.5, 33.7, 33.9, 34.1, 34.3, 34.5, 34.7, 34.9, 35.1, 35.3, 35.5, 35.7, 35.9, 36.01, 36.03, 36.05, 36.07, 36.09, 36.11, 36.13, 36.15, 36.17, 36.19, 36.21, 36.23, 36.25, 36.27, 36.29, 36.31, 36.33, 36.35, 36.37, 36.39, 36.41, 36.43, 36.45, 36.47, 36.49, 36.51, 36.53, 36.55, 36.57, 36.59, 36.61, 36.63, 36.65, 36.67, 36.69, 36.71, 36.73, 36.75, 36.77, 36.79, 36.81, 36.83, 36.85, 36.87, 36.89, 36.91, 36.93, 36.95, 36.97, 36.99, 37.01, 37.03, 37.05, 37.07, 37.09, 37.11, 37.13, 37.15, 37.17, 37.19, 37.21, 37.23, 37.25, 37.27, 37.29, 37.31, 37.33, 37.35, 37.37, 37.39/)
sig_bnds=(/30.0, 30.2, 30.4, 30.6, 30.8, 31, 31.2, 31.4, 31.6, 31.8, 32, 32.2, 32.4, 32.6, 32.8, 33, 33.2, 33.4, 33.6, 33.8, 34, 34.2, 34.4, 34.6, 34.8, 35, 35.2, 35.4, 35.6, 35.8, 36, 36.02, 36.04, 36.06, 36.08, 36.1, 36.12, 36.14, 36.16, 36.18, 36.2, 36.22, 36.24, 36.26, 36.28, 36.3, 36.32, 36.34, 36.36, 36.38, 36.4, 36.42, 36.44, 36.46, 36.48, 36.5, 36.52, 36.54, 36.56, 36.58, 36.6, 36.62, 36.64, 36.66, 36.68, 36.7, 36.72, 36.74, 36.76, 36.78, 36.8, 36.82, 36.84, 36.86, 36.88, 36.9, 36.92, 36.94, 36.96, 36.98, 37, 37.02, 37.04, 37.06, 37.08, 37.1, 37.12, 37.14, 37.16, 37.18, 37.2, 37.22, 37.24, 37.26, 37.28, 37.3, 37.32, 37.34, 37.36, 37.38, 37.4/)

DIR_out=getenv("DIR_FIGS")

if(tochar(getenv("figs_type")).eq."")then
   figs_type="png"
else
   figs_type=getenv("figs_type")
end if
;figs_type="png"
print(""+figs_type)

DIR_FIG=getenv("DIR_FIG")
wks   = gsn_open_wks(figs_type,DIR_FIG+"trans_"+lat0+"_climate_TS_plot")

;gsn_define_colormap(wks,"BlRe")
;gsn_define_colormap(wks,"BlueRed")
;gsn_define_colormap(wks,"MPL_bwr")
gsn_define_colormap(wks,"NCV_jaisnd")
;***************************************************************************************************************************
;              resource for public
;***************************************************************************************************************************
res                      = True
res@gsnFrame             = False
res@gsnDraw              = False
res@vpWidthF             = 0.4
res@vpHeightF            = 0.5
;res@vpXF             = 0.2
;res@vpYF            = 0.8
;res@gsnMaximize          = True
res@gsnLeftString              = ""
res@gsnRightString             = ""
res@gsnCenterString            = ""

res@cnInfoLabelOn        = False
res@tmXBLabelsOn          = False
res@tmXBOn                = True
res@tmXTOn                = False
res@tmYROn               = False

res0=res

res0@cnFillMode           = "CellFill"
res0@cnFillOn             = True
res0@cnLevelSelectionMode = "ExplicitLevels"
;res0@cnLevels             = (/-0.5,-0.45,-0.4,-0.35,-0.3,-0.25,-0.2,-0.15,-0.1,-0.09,-0.08,-0.07,-0.06,-0.05,-0.04,-0.03,-0.02,-0.01,0,0.01,0.02,0.03,0.04,0.05,0.06,0.07,0.08,0.09,0.1,0.15,0.2,0.25,0.3,0.35,0.4,0.45,0.5/)
res0@cnLineLabelsOn       = False
res0@cnLinesOn            = False
res0@lbLabelBarOn         = False
res0@tiXAxisString        = "Salinity (S) psu"
res0@tiYAxisString        = "Pot. Temperature (~F8~q~N~~F21~) ~S~o~N~C"

resc=res
resc@cnLevelSelectionMode = "ExplicitLevels"  ; use explicit levels
resc@cnLinesOn            = True 
resc@cnLineDashPattern    = 1 
resc@cnLineThicknessF     = 1
resc@cnLineLabelsOn       = True 
resc@cnLineLabelBackgroundColor = -1
resc@cnLineLabelFontHeightF=0.015
;resc@cnLineLabelFontThicknessF=3 
resc@cnLineLabelPlacementMode ="Computed"
resc@cnLineLabelDensityF      =0.2

polyres                   = True                       ; marker resources
polyres@gsLineThicknessF  = 3 
  
txres                 = True
txres@txFontThicknessF = 2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
str=systemfunc("echo ${MODELS[*]}")
models=str_split(str, " ")
print("models="+models)
str=systemfunc("echo ${MODELS_RUNS[*]}")
models_runs=str_split(str, " ")
print("models_runs="+models_runs)
str=systemfunc("echo ${LEGENDS[*]}")
legends=str_split(str, " ")
print("legends="+legends)
str=systemfunc("echo ${TEXTS[*]}")
texts=str_split(str, " ")
print("texts="+texts)

DIR_in0=getenv("DIR_REF")+"/"

num_model=dimsizes(models)

col=tointeger(floor(sqrt(num_model)))
row=tointeger(ceil(num_model*1.0/col))

;polyres@gsMarkerSizeF     = 0.018/min((/col,row/))
polyres@gsMarkerSizeF     = 0.03*1.4^(1-col)
txres@txFontHeightF = 0.03*1.1^(1-col)
print("gsMarkerSizeF: "+polyres@gsMarkerSizeF)
print("txFontHeightF: "+txres@txFontHeightF)

print(num_model+" "+row+" "+col)

plot0 = new((/num_model/),graphic)
plot1 = new((/num_model/),graphic)
plot2 = new((/num_model/),graphic)
txt   = new((/num_model/),graphic)
mk1   = new((/num_model,3/),graphic)
mk2   = new((/num_model,3/),graphic)
txts = new((/num_model,3,2/),graphic)

nc  = "sigma2_on_theta-salt_plane_high.nc"
;print("Now,the nc is:   "+nc)
fin = addfile(DIR_in0+nc,"r") 
sig = fin->sig2(0,:,:,0)
sig = sig - 1000.
theta = fin->theta
salt  = fin->salt

xmt=dimsizes(salt)
ymt=dimsizes(theta)
xmt=dimsizes(salt)
dat=new((/num_model,ymt,xmt/),"double",1e20)

;;;  trans_high_ACCESS1-0_r1i1p1_1850-2005_26.5.nc
nn=0
;------------------------------------------------------------------------------Contour levels & Axis range
Xmin=999.
Xmax=-999.
Ymin=999.
Ymax=-999.
do mm=0,num_model-1
  nn=mm
  model=models(mm)
  DIR_in1    = getenv("DIR_DAT")+model+"/"
  ncs0=systemfunc("ls "+DIR_in1+"trans_high_"+models_runs(mm)+"_????-????_"+lat0+".nc|head -n 1")
  fin = addfile(ncs0,"r")
  vmo = dim_avg_n_Wrap(fin->trans,0)
  if(max(abs(vmo)).gt.1e4)then
     vmo= vmo/1e6
  end if
  if(max(abs(vmo)).gt.1e2)then
     vmo= vmo/1e3
  end if
  printMinMax(vmo,False)

  dat(mm,:,:)=vmo(:,:,0)
  if(mm.eq.0)then
     min0=min(vmo)
     max0=max(vmo)
  else
     min0=min( (/min(vmo),min0/) )
     max0=max( (/max(vmo),max0/) )
  end if
  print(nn+" "+mm+" "+min0+" "+max0+" "+model)

  X_QS=dim_sum_n_Wrap(vmo,0)
  Y_QT=dim_sum_n_Wrap(vmo,1)
;  printVarSummary(X_QS)
;  printVarSummary(Y_QT)
  Xmin=tofloat(min((/Xmin, min(salt(ind(.not.ismissing(X_QS(:,0)))))/)))
  Xmax=tofloat(max((/Xmax, max(salt(ind(.not.ismissing(X_QS(:,0)))))/)))
  Ymin=tofloat(min((/Ymin, min(theta(ind(.not.ismissing(Y_QT(:,0)))))/)))
  Ymax=tofloat(max((/Ymax, max(theta(ind(.not.ismissing(Y_QT(:,0)))))/)))

  delete(vmo)
  delete(X_QS)
  delete(Y_QT)
end do

Xmin=floor(Xmin*10)/10.
Xmax=ceil(Xmax*10)/10.
Ymin=floor(Ymin*10)/10.
Ymax=ceil(Ymax*10)/10.
print("X:"+Xmin+" "+Xmax+" Y:"+Ymin+" "+Ymax)
res0@trXMinF = Xmin
res0@trXMaxF = Xmax
res0@trYMinF = Ymin
res0@trYMaxF = Ymax

;------------------------------------------------------------------------------Contour levels & Axis range
dat_oned=ndtooned(dat)
idx=ind(.not.ismissing(dat_oned))
vmo = abs(dat_oned(idx))
num_vald=dimsizes(vmo)
num_bins=10
num_point=num_vald/num_bins
levels=new(2*num_bins+1,"float",1e20)
counts=new(2*num_bins+1,"float",1e20)
levels(num_bins)=0
counts=0

print("num_vald"+num_vald)
print(min(vmo)+" "+max(vmo))
d=0.00001
left=0.
n=1
do i=0,num_bins-1
   ipos=num_bins+1+i
   ineg=num_bins-1-i
   right=left+n*d
   cnt=num(vmo.ge.left)
   if(cnt.lt.num_point)then
      right=max( (/ min((/0.5, tofloat(max(vmo))/)), left+step /) )
      levels(ipos)=right
      levels(ineg)=-right
      counts(ipos)=cnt
      counts(ineg)=cnt
      pct=1.*cnt/num_vald
      print(i+" ["+left+","+right+") "+pct)
      break
   end if
   cnt=num(vmo.ge.left .and. vmo.lt.right)
if(cnt .lt. num_point)then   
   do while (cnt .lt. num_point)
      n=n+1
      right=left+n*d
      cnt=num(vmo.ge.left .and. vmo.lt.right)
   end do
else if (cnt .gt. num_point)then   
   do while (cnt .gt. num_point .and. n.ge.2)
      n=n-1
      right=left+n*d
      cnt=num(vmo.ge.left .and. vmo.lt.right)
   end do
end if   
end if   
   vmo = where(vmo.ge.left .and. vmo.lt.right, vmo@_FillValue, vmo)
   levels(ipos)=right
   levels(ineg)=-right
   counts(ipos)=cnt
   counts(ineg)=cnt
   pct=1.*cnt/num_vald
   print(i+" ["+left+","+right+") "+pct)
   step=right-left
   left=right
end do
;levels(0:num_bins)=-levels(num_bins:2*num_bins:-1)
print(counts+" "+levels*10000.)
delete(vmo)
levels=round(levels/d,3)*d

print("Axis: "+Xmin+" "+Xmax+" "+Ymin+" "+Ymax)
;------------------------------------------------------------------------------Contour levels & Axis range

;------------------------------------------------------------------------------model
;====================================================================================================
; k = 0       1       2         3         4 
;  upper, middle0, lower0, middle_min, lower_min  
; i = 0       1       2         3
;   Net, Positive, Negative, absolute
ks=(/0,1,2/)
is=(/1,2/)

nn=0
do mm=0,num_model-1
;  nn=mm
  model=models(mm)
  DIR_in1    = getenv("DIR_DAT")+model+"/"

  ;;;  trans_high_ACCESS1-0_r1i1p1_1850-2005_26.5.nc
  ncs1=systemfunc("ls "+DIR_in1+"trans_high_"+models_runs(mm)+"_????-????_"+lat0+".nc|head -n 1")
  fin1 = addfile(ncs1,"r")
  vmo = dim_avg_n_Wrap(fin1->trans(:,:,:,0),0)
  if(max(abs(vmo)).gt.1e4)then
    vmo= vmo/1e6
  end if
  if(max(abs(vmo)).gt.1e2)then
    vmo= vmo/1e3
  end if

  ;;; AMOC32_high_ACCESS1-0_r1i1p1_1850-2005_26.5.nc
  ncs2=systemfunc("ls "+DIR_in1+"AMOC"+rmt+"_high_"+models_runs(mm)+"_????-????_"+lat0+".nc|head -n 1")
  fin2 = addfile(ncs2,"r")
  sig_max = dim_avg_n_Wrap(fin2->sig_max(:,0),0)
  sig_000 = dim_avg_n_Wrap(fin2->sig_000(:,0),0)
  sig_min = dim_avg_n_Wrap(fin2->sig_min(:,0),0)

  ;;;  trans32_avg_high_ACCESS1-0_r1i1p1_1850-2005_26.5.nc
  ncs3=systemfunc("ls "+DIR_in1+"trans"+rmt+"_avg_high_"+models_runs(mm)+"_????-????_"+lat0+".nc|head -n 1")
  fin3 = addfile(ncs3,"r")
  trans= dim_avg_n_Wrap(fin3->trans(:,ks,0,is),0)

  ;;; thetao32_wgt_high_ACCESS1-0_r1i1p1_1850-2005_26.5.nc
  ncs4=systemfunc("ls "+DIR_in1+"thetao"+rmt+"_wgt_high_"+models_runs(mm)+"_????-????_"+lat0+".nc|head -n 1")
;  print("Now,the nc is:   "+nc)
  fin4= addfile(ncs4,"r") 
  thetao= dim_avg_n_Wrap(fin4->thetao(:,ks,0,is),0)

  ;;;     so32_wgt_high_ACCESS1-0_r1i1p1_1850-2005_26.5.nc
  ncs5=systemfunc("ls "+DIR_in1+"so"+rmt+"_wgt_high_"+models_runs(mm)+"_????-????_"+lat0+".nc|head -n 1")
  fin5= addfile(ncs5,"r") 
  so= dim_avg_n_Wrap(fin5->so(:,ks,0,is),0)
  
  if(mod(nn,col).eq.0)then
    res0@tmYLLabelsOn =True
    resc@tmYLLabelsOn =True
    res0@tiYAxisOn    =True
    resc@tiYAxisOn    =True
  else
    res0@tmYLLabelsOn =False
    resc@tmYLLabelsOn =False
    res0@tiYAxisOn    =False
    resc@tiYAxisOn    =False
  end if

  if(nn/col.eq.row-1)then
;    print("XB_ON")
    res0@tmXBLabelsOn =True
    resc@tmXBLabelsOn =True
    res0@tiXAxisOn    =True
    resc@tiXAxisOn    =True
  else
    res0@tmXBLabelsOn =False
    resc@tmXBLabelsOn =False
    res0@tiXAxisOn    =False
    resc@tiXAxisOn    =False
  end if

if(nn.eq.0)then
;  printVarSummary(vmo)
;  printVarSummary(tmp)
;  printVarSummary(sig)
  res0@cnLevels     = levels
;  res0@cnLevels             = (/-0.5,-0.45,-0.4,-0.35,-0.3,-0.25,-0.2,-0.15,-0.1,-0.09,-0.08,-0.07,-0.06,-0.05,-0.04,-0.03,-0.02,-0.01,0,0.01,0.02,0.03,0.04,0.05,0.06,0.07,0.08,0.09,0.1,0.15,0.2,0.25,0.3,0.35,0.4,0.45,0.5/)
;  print(""+res0@cnLevels)
end if
  plot0(nn) = gsn_csm_contour(wks,vmo,res0)
  resc@cnLevels     = (/sig_max/)
  resc@cnLineLabelFontColor  ="black"
  plot1(nn) = gsn_csm_contour(wks,sig,resc)
  resc@cnLevels     = (/sig_000/)
  resc@cnLineLabelFontColor  ="black"
  plot2(nn) = gsn_csm_contour(wks,sig,resc)
  overlay(plot0(nn),plot1(nn))
  overlay(plot0(nn),plot2(nn))
  txres@txJust      = "CenterCenter"
  txres@txFontColor = "black"
  txt(nn)   = gsn_add_text   (wks,plot0(nn),legends(mm),(res0@trXMinF+res0@trXMaxF)/2.,res0@trYMinF+0.95*(res0@trYMaxF-res0@trYMinF),txres)

;====================================================================================================
  polyres@gsMarkerIndex     = 11                         ; index for circle
  polyres@gsMarkerColor     = "black"
  xx=(/so(0,0)/) 
  yy=(/thetao(0,0)/)
  mk1(mm,0) = gsn_add_polymarker(wks,plot0(mm),xx,yy,polyres)
  polyres@gsMarkerIndex     = 10                         ; index for circle
  polyres@gsMarkerColor     = "black"
  xx=(/so(0,1)/) 
  yy=(/thetao(0,1)/)
  mk2(mm,0)  = gsn_add_polymarker(wks,plot0(mm),xx,yy,polyres)

;  polyres@gsMarkerThicknessF= 1 
  polyres@gsMarkerIndex     = 11
  polyres@gsMarkerColor     = "black"
  xx=(/so(1,0)/) 
  yy=(/thetao(1,0)/)
  mk1(mm,1) = gsn_add_polymarker(wks,plot0(mm),xx,yy,polyres)
  polyres@gsMarkerIndex     = 10                         ; index for circle
  polyres@gsMarkerColor     = "black"
  xx=(/so(1,1)/) 
  yy=(/thetao(1,1)/)
  mk2(mm,1)  = gsn_add_polymarker(wks,plot0(mm),xx,yy,polyres)

  polyres@gsMarkerIndex     = 11
  polyres@gsMarkerColor     = "black"
  xx=(/so(2,0)/) 
  yy=(/thetao(2,0)/)
;  mk1(mm,2) = gsn_add_polymarker(wks,plot0(mm),xx,yy,polyres)
  polyres@gsMarkerIndex     = 10                         ; index for circle
  polyres@gsMarkerColor     = "black"
  xx=(/so(2,1)/) 
  yy=(/thetao(2,1)/)
;  mk2(mm,2)  = gsn_add_polymarker(wks,plot0(mm),xx,yy,polyres)
;====================================================================================================

;if(num_model .lt. 20)then
if(num_model .lt. 14)then
  txres@txFontHeightF = 0.02*1.4^(1-col)
  print("txFontHeightF: "+txres@txFontHeightF )

  vmo_strs=tostring_with_format((/trans/), "%4.2f")+ " Sv"
  ttt_strs=tostring_with_format((/thetao/),"%4.2f")
  sss_strs=tostring_with_format((/so/),    "%4.2f")
  ts0_strs="[ "+tostring_with_format((/thetao/),"%4.2f")+", "+tostring_with_format((/so/),"%4.2f")+" ]"

  txres@txJust      = "CenterLeft"
  txres@txFontColor = "red"
;==================== layer1 positive ====================
  xxx = Xmin+0.1*(Xmax-Xmin)
  yyy = Ymax-0.1*(Ymax-Ymin)
  txts(mm,0,0) = gsn_add_text(wks,plot0(mm),vmo_strs(0,0), xxx, yyy,txres)

;==================== layer2 positive ====================
  xxx = Xmin+0.1*(Xmax-Xmin)
  yyy = Ymin+0.1*(Ymax-Ymin)
  txts(mm,1,0) = gsn_add_text(wks,plot0(mm),vmo_strs(1,0), xxx, yyy,txres)

  txres@txFontColor = "blue"
  txres@txJust      = "CenterRight"
;==================== layer1 negative ====================
  xxx = Xmax-0.1*(Xmax-Xmin)
  yyy = Ymax-0.1*(Ymax-Ymin)
  txts(mm,0,1) = gsn_add_text(wks,plot0(mm),vmo_strs(0,1), xxx, yyy,txres)
;==================== layer2 negative ====================
  xxx = Xmax-0.1*(Xmax-Xmin)
  yyy = Ymin+0.1*(Ymax-Ymin)
  txts(mm,1,1) = gsn_add_text(wks,plot0(mm),vmo_strs(1,1), xxx, yyy,txres)
end if

  delete(vmo)
  delete(sig_max)
  delete(sig_000)
  delete(sig_min)
  delete(trans)
  delete(thetao)
  delete(so)
  
  nn=nn+1
end do ;;; model loop

res1                     = True
res2                     = True
res3                     = True
res1@gsnMaximize         = True
res2@gsnAttachPlotsYAxis = True
res3@gsnAttachPlotsXAxis = True

if(num_model.gt.1)then
attachY=new((/row,max((/col-1,1/))/),"graphic")
print(num_model+" "+row+" "+col)
do r=0,row-1
  ca=r*col+1
  cb=min((/num_model-1, (r+1)*col-1/))
  if(cb.lt.ca)then
     continue
  end if
  c0=ca-1
  print("r="+r+" c0="+c0+" ca="+ca+" cb="+cb)
  attachY(r,0:cb-ca) = gsn_attach_plots(plot0(c0),(/plot0(ca:cb)/),res1,res2)
end do

ids=ispan(0,num_model-1,col)
num_ids=dimsizes(ids)
attachX = gsn_attach_plots(plot0(0),(/plot0(ids(1:num_ids-1))/),res1,res3)

end if

;***************************************************************************************************************************
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;      resourse for Panel plot
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
resP                            = True
resP@gsnMaximize                = True
resP@gsnPanelLabelBar           = True
;if(row.gt.col)then
;   resP@lbOrientation               = "Vertical"     ; vertical label bar
;   resP@pmLabelBarWidthF           = 0.04
;else
   resP@lbOrientation               = "Horizontal"   ; vertical label bar
   resP@pmLabelBarHeightF          = 0.03
;end if
resP@lbLabelAutoStride          = True
resP@lbLabelFontHeightF         =0.006
;resP@pmLabelBarOrthogonalPosF   = -0.02
;resP@pmLabelBarParallelPosF     = -0.05
;resP@gsnPanelRowSpec = True
;resP@gsnPanelCenter = False
resP@gsnPaperOrientation        = "auto"
gsn_panel(wks,plot0(0),(/1,1/),resP)

fig=DIR_FIG+"trans_"+lat0+"_climate_xz_plot."+figs_type
cmd = "convert -trim +repage -border 8 -bordercolor white -background white -flatten "+fig+" "+fig
; system(cmd)

;***************************************************************************************************************************
;***************************************************************************************************************************

xpos=(/0.16,0.33,0.51,0.67,0.83/)
ypos=(/0.89,0.685,0.485,0.285/)

