#!/bin/bash
name1=${0##*/}
name2=${name1%%.*}

source /${driver}
script="trans_lat0_yearly_env.ncl"
echo ${exps[*]}

for exp   in ${exps[*]};do
   n=0
for model in ${models[*]};do
for run   in ${runs[*]};do

    export RUN=${run}

num=${#dTs[@]}
((num--))
echo $num
for d in `seq 0 ${num}`; do
    export DT=${dTs[${d}]}
    export DS=${dSs[${d}]}
    export resol=${resols[${d}]}

    n=0
    #--- set directory of Q T S and dimensions ---
    case ${DIR_TREE_TYPE} in
    0)
    export DIR_THETAO="${DIR_CMIP}/${exp}/${model}/${run}/"
    export DIR_SO="${DIR_CMIP}/${exp}/${model}/${run}/"
    export DIR_VMO="${DIR_CMIP}/${exp}/${model}/${run}/"
    ;;
    1)
    export DIR_THETAO="${DIR_CMIP}/${exp}/${model}/"
    export DIR_SO="${DIR_CMIP}/${exp}/${model}/"
    export DIR_VMO="${DIR_CMIP}/${exp}/${model}/"
    ;;
    2)
    export DIR_THETAO="${DIR_CMIP}/${model}/${exp}/${run}/"
    export DIR_SO="${DIR_CMIP}/${model}/${exp}/${run}/" 
    export DIR_VMO="${DIR_CMIP}/${model}/${exp}/${run}/"
    ;;
    3)
    export DIR_THETAO="${DIR_CMIP}/${model}/${exp}/"
    export DIR_SO="${DIR_CMIP}/${model}/${exp}/"
    export DIR_VMO="${DIR_CMIP}/${model}/${exp}/"
    ;;
    *)
    #---   USER DEFINE THEIR OWN DIRECTORY TREE HERE. some common configurature.
    export DIR_SO="${DIR_CMIP}/${model}/"
    export DIR_SO="${DIR_CMIP}/${run}/${model}/${exp}/"
    export DIR_SO="${DIR_CMIP}/${run}/${model}/"
    export DIR_SO="${DIR_CMIP}/${run}/${exp}/${model}/"
    export DIR_SO="${DIR_CMIP}/${model}/so/"
    ;;
    esac

    echo "${DIR_TREE_TYPE}: ${DIR_SO}"

    export DIR_OUT="${DIR_DIAG}/${exp}/${model}/annual/"
    #####################################################################################################################################
    ########################################## USER DEFINED END, DO NOT MODIFY BELOW ####################################################
    #####################################################################################################################################
    [[ ! -d ${DIR_OUT} ]] && mkdir -p ${DIR_OUT}
    export MODEL=${model}
    export TIME=${tims[${n}]}
    export LEV=${levs[${n}]}
    export LAT=${lats[${n}]}
    export LON=${lons[${n}]}
 
    nnn=`ls ${DIR_VMO}/${vmo}_Omon_${model}_*_??????-??????.nc|wc -l`
    [[ ${nnn} -ge 1 ]] && export var="${vmo}" || export var="${vo}"         ### use vmo if exists, else use vo to recover vmo.
#----------------------------------------------------------------------------------------------------     
#---    2020-07-29 bug found.
#---    works fine if run one period to another: vmo used then vo skipped;
#---    bad when parallel by submitting to nodes: vmo used but then replaced by vo;
#        for vmo in `ls ${DIR_VMO}/v*o_Omon_${model}_*_??????-??????.nc`;do
#----------------------------------------------------------------------------------------------------     
    for nc_vmo in `ls ${DIR_VMO}/${var}_Omon_${model}_*_??????-??????.nc`;do
#        for nc in `ls ${DIR_VMO}/${var}_Omon_${model}_*_19[32]???-??????.nc`;do
#        for nc in `ls ${DIR_VMO}/${var}_Omon_${model}_*_2?????-??????.nc`;do
        echo ${nc_vmo}
        yymm=${nc_vmo##*_}
        yymm=${yymm%.nc}
        yyyy=${yymm:7:4}
        period="${yyyy}01-${yymm:7:6}"
        echo "---------------------------- ${model} ${run} ${yymm} ${yyyy} --------------------------------"
 
        #--- skip if already done ---
#       /nexsan/people/fwang/CMIP5/historical/AMOC_3D_Structure/diag/historical/ACCESS1-0/annual/trans_high_ACCESS1-0_r1i1p1_1850_192_26.5.nc
        num=`ls ${DIR_OUT}/trans_${resol}_${model}_${run}_${yyyy}_*_${LAT0}.nc|wc -l`
        [[ ${num} -ge 1 ]] && continue
        nc=`ls ${DIR_OUT}/trans_${resol}_${model}_${run}_*_*_${LAT0}.nc|head -n 1`
        nc=${nc%_*}
        jjj=${nc##*_}
        fout="${DIR_OUT}/trans_${resol}_${model}_${run}_${yyyy}_${jjj}_${LAT0}.nc"
        [[ -e ${fout} ]] && continue
        echo ${fout}
 
        #--- check if thetao & so exists ---
        nc_so="${DIR_SO}${so}_${nc_vmo#*_}"
        [[ ! -e ${nc_so}  ]] &&  echo "NOT EXIST: ${nc_so}" && continue
        nc_to="${DIR_THETAO}${thetao}_${nc_vmo#*_}"
        [[ ! -e ${nc_to} ]] && echo "NOT EXIST: ${nc_to}" && continue
        echo "so : ${nc_so}"
        echo "to : ${nc_to}"
        echo "vmo: ${nc_vmo}"
 
        #--- set Q T S filenames and period ---
        export THETAO="${nc_to##*/}"
        export SO="${nc_so##*/}"
        export VMO="${nc_vmo##*/}"
        export YYMM=${yymm}
 
        #--- ncl script for this period     ---
        tim=`date "+%Y%m%d%H%M%S"`
        ncl=${DIR_LOGS}/${RUN_TIM}/${name2}_${model}_${run}_${yymm}_${resol}_${tim}.ncl
        log=${DIR_LOGS}/${RUN_TIM}/${name2}_${model}_${run}_${yymm}_${resol}_${tim}.log
        cp ${script} ${ncl}

     if [[ ${use_node} -eq 1 ]];then
        exe=${DIR_LOGS}/${RUN_TIM}/${name2}_${model}_${run}_${yymm}_${resol}_${tim}.slurm
        cp ${myjob}  ${exe}
        sed -i "s#./myjob.sh#ncl ${ncl}#g" ${exe}
        sed -i "s#17125823#${log%.log}#g" ${exe}
        sed -i "s#RUN_LOG#${log}#g" ${exe}
        sbatch ${exe}
        sleep 1
     else        
#------------------------------------------------------------------------------   
#---    CHESK LOAD: if load is low then submit, else if 
#---    load is high wait another 1 minute until load becomes low then submit 
        flag=0
        while [[ ${flag} -eq 0 ]];do   
           flag=0
           LOAD=`uptime|cut -d ',' -f4|awk '{print $3}'`
           echo "${LOAD} ${CPU}"
           if [[ `echo "${LOAD} < ${CPU}" | bc` -eq 1 ]]; then 
              flag=1
              echo "LOAD is low, submit job"
              nohup ncl -Q ${ncl} > ${log} 2>&1 &
              sleep 10
              LOAD=`uptime|cut -d ',' -f5`
           fi
           [[ ${flag} -eq 0 ]] && read -t 7 -p "LOAD:${LOAD} > CPU:${CPU}" temp
        done
     fi   
done #--- files loop
done #--- dT dS loop
done #--- run   loop
done #--- model loop
done #--- exp   loop

times
