load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_csm.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/shea_util.ncl"

ncs0=getenv("nc_sig")
ncs1=getenv("fin1")
ncs2=getenv("nc_trans")

eps=1e-8
;====================================================================================================
nc  = ncs0
print("Loading ... "+nc)
fin = addfile(nc,"r") 
sig2= tofloat(fin->sig2(0,:,:,0))
sig2= sig2 - 1000.

nc  = ncs1
print("Loading ... "+nc)
fin1 = addfile(nc,"r") 

nc  = ncs2
print("Loading ... "+nc)
fin2 = addfile(nc,"r") 
theta = tofloat(fin2->theta)
salt  = tofloat(fin2->salt)
lat = fin2->lat
num_theta=dimsizes(theta)
num_salt =dimsizes(salt )
num_lat  =dimsizes(lat  )

time= fin1->time
ymt=dimsizes(time)

tt  =conform_dims((/num_theta,num_salt,num_lat/),theta,(/0/))
ss  =conform_dims((/num_theta,num_salt,num_lat/),salt ,(/1/))
sig =conform_dims((/num_theta,num_salt,num_lat/),sig2 ,(/0,1/))

Tavg=new((/ymt,5,num_lat,4/),"double",1e20)
Savg=new((/ymt,5,num_lat,4/),"double",1e20)
Qavg=new((/ymt,5,num_lat,4/),"double",1e20)

do y=0,ymt-1
   print("y:"+y)
   moc = fin1->moc(y,:,:,0)
   sig_max = tofloat(fin1->sig_max(y,:))
   sig_000 = tofloat(fin1->sig_000(y,:))
   sig_min = tofloat(fin1->sig_min(y,:))
   moc_neg = tofloat(fin1->moc_neg(y,:))
   sig_neg = tofloat(fin1->sig_neg(y,:))
   ttt_neg = tofloat(fin1->ttt_neg(y,:))
   sss_neg = tofloat(fin1->sss_neg(y,:))
   
   trans = fin2->trans(y,:,:,:)
   
   Smax=conform_dims((/num_theta,num_salt,num_lat/),sig_max,(/2/))
   S000=conform_dims((/num_theta,num_salt,num_lat/),sig_neg,(/2/))
   Smin=conform_dims((/num_theta,num_salt,num_lat/),sig_min,(/2/))
   vit =new((/num_theta,num_salt,num_lat/),"integer",-9999)
   sit =new((/num_theta,num_salt,num_lat/),"integer",-9999)

   VT_offset=moc_neg
   VS_offset=moc_neg
   VT_offset=moc_neg*ttt_neg
   VS_offset=moc_neg*sss_neg

   ; 0:4, (,Smax], (Smax,S000], (S000,), (Smax,Smin], (Smin,)
   ; 0:3, net, pos, neg, abs
   
   ;====================================================================================================
   trans_abs=abs(trans)
   VT=trans
   VS=trans
   VT_abs=trans_abs
   VS_abs=trans_abs
   
   VT=trans*tt
   VS=trans*ss
   VT_abs=trans_abs*tt
   VS_abs=trans_abs*ss
   ;====================================================================================================
   ;  upper layer
   vit=where(sig+eps.le.Smax,1,vit@_FillValue)
   
   ;----------------------------------------------------------------------------------------------------
   ;  absolute
   Tsum=dim_sum_n_Wrap(dim_sum_n_Wrap(VT_abs*vit,0),0)
   Ssum=dim_sum_n_Wrap(dim_sum_n_Wrap(VS_abs*vit,0),0)
   wgt =dim_sum_n_Wrap(dim_sum_n_Wrap(trans_abs*vit,0),0)
   
   Tavg(y,0,:,3)=where(.not.ismissing(wgt),Tsum/wgt,Tavg@_FillValue)
   Savg(y,0,:,3)=where(.not.ismissing(wgt),Ssum/wgt,Savg@_FillValue)
   Qavg(y,0,:,3)=(/wgt/)
   
   ;----------------------------------------------------------------------------------------------------
   ;  net
   Tsum=dim_sum_n_Wrap(dim_sum_n_Wrap(VT*vit,0),0)
   Ssum=dim_sum_n_Wrap(dim_sum_n_Wrap(VS*vit,0),0)
   wgt =dim_sum_n_Wrap(dim_sum_n_Wrap(trans*vit,0),0)
   
   Tavg(y,0,:,0)=where(.not.ismissing(wgt),Tsum/wgt,Tavg@_FillValue)
   Savg(y,0,:,0)=where(.not.ismissing(wgt),Ssum/wgt,Savg@_FillValue)
   Qavg(y,0,:,0)=(/wgt/)
   
   ;----------------------------------------------------------------------------------------------------
   ;  positive
   sit=where(trans.gt.0,1,sit@_FillValue)
   
   Tsum=dim_sum_n_Wrap(dim_sum_n_Wrap(VT*vit*sit,0),0)
   Ssum=dim_sum_n_Wrap(dim_sum_n_Wrap(VS*vit*sit,0),0)
   wgt =dim_sum_n_Wrap(dim_sum_n_Wrap(trans*vit*sit,0),0)
   
   Tavg(y,0,:,1)=where(.not.ismissing(wgt),Tsum/wgt,Tavg@_FillValue)
   Savg(y,0,:,1)=where(.not.ismissing(wgt),Ssum/wgt,Savg@_FillValue)
   Qavg(y,0,:,1)=(/wgt/)
   
   ;----------------------------------------------------------------------------------------------------
   ;  negative
   sit=where(trans.le.0,1,sit@_FillValue)
   
   Tsum=dim_sum_n_Wrap(dim_sum_n_Wrap(VT*vit*sit,0),0)
   Ssum=dim_sum_n_Wrap(dim_sum_n_Wrap(VS*vit*sit,0),0)
   wgt =dim_sum_n_Wrap(dim_sum_n_Wrap(trans*vit*sit,0),0)
   
   Tavg(y,0,:,2)=where(.not.ismissing(wgt),Tsum/wgt,Tavg@_FillValue)
   Savg(y,0,:,2)=where(.not.ismissing(wgt),Ssum/wgt,Savg@_FillValue)
   Qavg(y,0,:,2)=(/wgt/)
   
   ;====================================================================================================
   ;  Middle layer 000
   vit=where(sig.gt.Smax .and. sig-eps.le.S000,1,vit@_FillValue)
;   print(theta+" "+vit(:,75,jjj)*sig(:,75,jjj)+" "+dim_sum_n_Wrap(trans(:,:,jjj)*vit(:,:,jjj),1))
   ;exit
   
   ;----------------------------------------------------------------------------------------------------
   ;  absolute
   Tsum=dim_sum_n_Wrap(dim_sum_n_Wrap(VT_abs*vit,0),0)
   Ssum=dim_sum_n_Wrap(dim_sum_n_Wrap(VS_abs*vit,0),0)
   wgt =dim_sum_n_Wrap(dim_sum_n_Wrap(trans_abs*vit,0),0)
   Tsum=Tsum+VT_offset
   Ssum=Ssum+VS_offset
   wgt=wgt+moc_neg

   Tavg(y,1,:,3)=where(.not.ismissing(wgt),Tsum/wgt,Tavg@_FillValue)
   Savg(y,1,:,3)=where(.not.ismissing(wgt),Ssum/wgt,Savg@_FillValue)
   Qavg(y,1,:,3)=(/wgt/)
   
   ;----------------------------------------------------------------------------------------------------
   ;  net
   Tsum=dim_sum_n_Wrap(dim_sum_n_Wrap(VT*vit,0),0)
   Ssum=dim_sum_n_Wrap(dim_sum_n_Wrap(VS*vit,0),0)
   wgt =dim_sum_n_Wrap(dim_sum_n_Wrap(trans*vit,0),0)
   Tsum = Tsum - VT_offset
   Ssum = Ssum - VS_offset
   wgt  = wgt - moc_neg
   
   Tavg(y,1,:,0)=where(.not.ismissing(wgt),Tsum/wgt,Tavg@_FillValue)
   Savg(y,1,:,0)=where(.not.ismissing(wgt),Ssum/wgt,Savg@_FillValue)
   Qavg(y,1,:,0)=(/wgt/)
   
   ;----------------------------------------------------------------------------------------------------
   ;  positive
   sit=where(trans.gt.0,1,sit@_FillValue)
   
   Tsum=dim_sum_n_Wrap(dim_sum_n_Wrap(VT*vit*sit,0),0) 
   Ssum=dim_sum_n_Wrap(dim_sum_n_Wrap(VS*vit*sit,0),0)
   wgt =dim_sum_n_Wrap(dim_sum_n_Wrap(trans*vit*sit,0),0)
   
   Tavg(y,1,:,1)=where(.not.ismissing(wgt),Tsum/wgt,Tavg@_FillValue)
   Savg(y,1,:,1)=where(.not.ismissing(wgt),Ssum/wgt,Savg@_FillValue)
   Qavg(y,1,:,1)=(/wgt/)
   
   ;----------------------------------------------------------------------------------------------------
   ;  negative
   sit=where(trans.le.0,1,sit@_FillValue)
   
   Tsum=dim_sum_n_Wrap(dim_sum_n_Wrap(VT*vit*sit,0),0)
   Ssum=dim_sum_n_Wrap(dim_sum_n_Wrap(VS*vit*sit,0),0)
   wgt =dim_sum_n_Wrap(dim_sum_n_Wrap(trans*vit*sit,0),0)
   Tsum = Tsum - VT_offset
   Ssum = Ssum - VS_offset
   wgt  = wgt - moc_neg
   
   Tavg(y,1,:,2)=where(.not.ismissing(wgt),Tsum/wgt,Tavg@_FillValue)
   Savg(y,1,:,2)=where(.not.ismissing(wgt),Ssum/wgt,Savg@_FillValue)
   Qavg(y,1,:,2)=(/wgt/)
   
;   print(Tavg(y,1,jjj,2)+" "+Savg(y,1,jjj,2)+" "+Qavg(y,1,jjj,2))
   ;====================================================================================================
   ;  Lower layer
   vit=where(sig.gt.S000,1,vit@_FillValue)
   
   ;----------------------------------------------------------------------------------------------------
   ;  absolute
   Tsum=dim_sum_n_Wrap(dim_sum_n_Wrap(VT_abs*vit,0),0)
   Ssum=dim_sum_n_Wrap(dim_sum_n_Wrap(VS_abs*vit,0),0)
   wgt =dim_sum_n_Wrap(dim_sum_n_Wrap(trans_abs*vit,0),0)
   Tsum=Tsum-VT_offset
   Ssum=Ssum-VS_offset
   wgt=wgt-moc_neg
   
   Tavg(y,2,:,3)=where(.not.ismissing(wgt),Tsum/wgt,Tavg@_FillValue)
   Savg(y,2,:,3)=where(.not.ismissing(wgt),Ssum/wgt,Savg@_FillValue)
   Qavg(y,2,:,3)=(/wgt/)
   
   ;----------------------------------------------------------------------------------------------------
   ;  net
   Tsum=dim_sum_n_Wrap(dim_sum_n_Wrap(VT*vit,0),0)
   Ssum=dim_sum_n_Wrap(dim_sum_n_Wrap(VS*vit,0),0)
   wgt =dim_sum_n_Wrap(dim_sum_n_Wrap(trans*vit,0),0)
   Tsum = Tsum + VT_offset
   Ssum = Ssum + VS_offset
   wgt  = wgt + moc_neg
   
   Tavg(y,2,:,0)=where(.not.ismissing(wgt),Tsum/wgt,Tavg@_FillValue)
   Savg(y,2,:,0)=where(.not.ismissing(wgt),Ssum/wgt,Savg@_FillValue)
   Qavg(y,2,:,0)=(/wgt/)
   
   ;----------------------------------------------------------------------------------------------------
   ;  positive
   sit=where(trans.gt.0,1,sit@_FillValue)
   
   Tsum=dim_sum_n_Wrap(dim_sum_n_Wrap(VT*vit*sit,0),0)
   Ssum=dim_sum_n_Wrap(dim_sum_n_Wrap(VS*vit*sit,0),0)
   wgt =dim_sum_n_Wrap(dim_sum_n_Wrap(trans*vit*sit,0),0)
   
   Tavg(y,2,:,1)=where(.not.ismissing(wgt),Tsum/wgt,Tavg@_FillValue)
   Savg(y,2,:,1)=where(.not.ismissing(wgt),Ssum/wgt,Savg@_FillValue)
   Qavg(y,2,:,1)=(/wgt/)
   
   ;----------------------------------------------------------------------------------------------------
   ;  negative
   sit=where(trans.le.0,1,sit@_FillValue)
   
   Tsum=dim_sum_n_Wrap(dim_sum_n_Wrap(VT*vit*sit,0),0)
   Ssum=dim_sum_n_Wrap(dim_sum_n_Wrap(VS*vit*sit,0),0)
   wgt =dim_sum_n_Wrap(dim_sum_n_Wrap(trans*vit*sit,0),0)
   Tsum = Tsum + VT_offset
   Ssum = Ssum + VS_offset
   wgt  = wgt + moc_neg
   
   Tavg(y,2,:,2)=where(.not.ismissing(wgt),Tsum/wgt,Tavg@_FillValue)
   Savg(y,2,:,2)=where(.not.ismissing(wgt),Ssum/wgt,Savg@_FillValue)
   Qavg(y,2,:,2)=(/wgt/)
   
   ;====================================================================================================
   ;  Middle layer min
   vit=where(sig.gt.Smax .and. sig+eps.le.Smin,1,vit@_FillValue)
   
   ;----------------------------------------------------------------------------------------------------
   ;  absolute
   Tsum=dim_sum_n_Wrap(dim_sum_n_Wrap(VT_abs*vit,0),0)
   Ssum=dim_sum_n_Wrap(dim_sum_n_Wrap(VS_abs*vit,0),0)
   wgt =dim_sum_n_Wrap(dim_sum_n_Wrap(trans_abs*vit,0),0)
   
   Tavg(y,3,:,3)=where(.not.ismissing(wgt),Tsum/wgt,Tavg@_FillValue)
   Savg(y,3,:,3)=where(.not.ismissing(wgt),Ssum/wgt,Savg@_FillValue)
   Qavg(y,3,:,3)=(/wgt/)
   
   ;----------------------------------------------------------------------------------------------------
   ;  net
   Tsum=dim_sum_n_Wrap(dim_sum_n_Wrap(VT*vit,0),0)
   Ssum=dim_sum_n_Wrap(dim_sum_n_Wrap(VS*vit,0),0)
   wgt =dim_sum_n_Wrap(dim_sum_n_Wrap(trans*vit,0),0)
   
   Tavg(y,3,:,0)=where(.not.ismissing(wgt),Tsum/wgt,Tavg@_FillValue)
   Savg(y,3,:,0)=where(.not.ismissing(wgt),Ssum/wgt,Savg@_FillValue)
   Qavg(y,3,:,0)=(/wgt/)
   
   ;----------------------------------------------------------------------------------------------------
   ;  positive
   sit=where(trans.gt.0,1,sit@_FillValue)
   
   Tsum=dim_sum_n_Wrap(dim_sum_n_Wrap(VT*vit*sit,0),0)
   Ssum=dim_sum_n_Wrap(dim_sum_n_Wrap(VS*vit*sit,0),0)
   wgt =dim_sum_n_Wrap(dim_sum_n_Wrap(trans*vit*sit,0),0)
   
   Tavg(y,3,:,1)=where(.not.ismissing(wgt),Tsum/wgt,Tavg@_FillValue)
   Savg(y,3,:,1)=where(.not.ismissing(wgt),Ssum/wgt,Savg@_FillValue)
   Qavg(y,3,:,1)=(/wgt/)
   
   ;----------------------------------------------------------------------------------------------------
   ;  negative
   sit=where(trans.le.0,1,sit@_FillValue)
   
   Tsum=dim_sum_n_Wrap(dim_sum_n_Wrap(VT*vit*sit,0),0)
   Ssum=dim_sum_n_Wrap(dim_sum_n_Wrap(VS*vit*sit,0),0)
   wgt =dim_sum_n_Wrap(dim_sum_n_Wrap(trans*vit*sit,0),0)
   
   Tavg(y,3,:,2)=where(.not.ismissing(wgt),Tsum/wgt,Tavg@_FillValue)
   Savg(y,3,:,2)=where(.not.ismissing(wgt),Ssum/wgt,Savg@_FillValue)
   Qavg(y,3,:,2)=(/wgt/)
   
   ;====================================================================================================
   ;  Lower layer min
   vit=where(sig.gt.Smin,1,vit@_FillValue)
   
   ;----------------------------------------------------------------------------------------------------
   ;  absolute
   Tsum=dim_sum_n_Wrap(dim_sum_n_Wrap(VT_abs*vit,0),0)
   Ssum=dim_sum_n_Wrap(dim_sum_n_Wrap(VS_abs*vit,0),0)
   wgt =dim_sum_n_Wrap(dim_sum_n_Wrap(trans_abs*vit,0),0)
   
   Tavg(y,4,:,3)=where(.not.ismissing(wgt),Tsum/wgt,Tavg@_FillValue)
   Savg(y,4,:,3)=where(.not.ismissing(wgt),Ssum/wgt,Savg@_FillValue)
   Qavg(y,4,:,3)=(/wgt/)
   
   ;----------------------------------------------------------------------------------------------------
   ;  net
   Tsum=dim_sum_n_Wrap(dim_sum_n_Wrap(VT*vit,0),0)
   Ssum=dim_sum_n_Wrap(dim_sum_n_Wrap(VS*vit,0),0)
   wgt =dim_sum_n_Wrap(dim_sum_n_Wrap(trans*vit,0),0)
   
   Tavg(y,4,:,0)=where(.not.ismissing(wgt),Tsum/wgt,Tavg@_FillValue)
   Savg(y,4,:,0)=where(.not.ismissing(wgt),Ssum/wgt,Savg@_FillValue)
   Qavg(y,4,:,0)=(/wgt/)
   
   ;----------------------------------------------------------------------------------------------------
   ;  positive
   sit=where(trans.gt.0,1,sit@_FillValue)
   
   Tsum=dim_sum_n_Wrap(dim_sum_n_Wrap(VT*vit*sit,0),0)
   Ssum=dim_sum_n_Wrap(dim_sum_n_Wrap(VS*vit*sit,0),0)
   wgt =dim_sum_n_Wrap(dim_sum_n_Wrap(trans*vit*sit,0),0)
   
   Tavg(y,4,:,1)=where(.not.ismissing(wgt),Tsum/wgt,Tavg@_FillValue)
   Savg(y,4,:,1)=where(.not.ismissing(wgt),Ssum/wgt,Savg@_FillValue)
   Qavg(y,4,:,1)=(/wgt/)
   
   ;----------------------------------------------------------------------------------------------------
   ;  negative
   sit=where(trans.le.0,1,sit@_FillValue)
   
   Tsum=dim_sum_n_Wrap(dim_sum_n_Wrap(VT*vit*sit,0),0)
   Ssum=dim_sum_n_Wrap(dim_sum_n_Wrap(VS*vit*sit,0),0)
   wgt =dim_sum_n_Wrap(dim_sum_n_Wrap(trans*vit*sit,0),0)
   Tavg(y,4,:,2)=where(.not.ismissing(wgt),Tsum/wgt,Tavg@_FillValue)
   Savg(y,4,:,2)=where(.not.ismissing(wgt),Ssum/wgt,Savg@_FillValue)
   Qavg(y,4,:,2)=(/wgt/)
   
   delete(Smax)
   delete(S000)
   delete(Smin)
   delete(vit)
   delete(sit)
end do   
   ;====================================================================================================
   tmp=Tavg
   tmp!0="time"
   tmp!1="lev"
   tmp!2="lat"
   tmp!3="lon"
   tmp&time=time
   tmp&time@long_name="time"
   tmp&time@units    ="days since 1850-01-01 00:00"
   tmp&lev=(/0.,1.,2.,3.,4./)
   tmp&lev@long_name="lev"
   tmp&lev@units    ="m"
   tmp&lon=(/0.,1.,2.,3./)
   tmp&lon@long_name="longitude"
   tmp&lon@units    ="degrees_east"
   tmp&lat  =lat  
   tmp&lev@note = "0:4, (,Smax], (Smax,S000], (S000,), (Smax,Smin], (Smin,)"
   tmp&lon@note = "0:3, net, pos, neg, abs"
   
   ; Tavg=new((/ymt,5,num_lat,4/),"float",1e20)
   ; 0:4, (,Smax], (Smax,S000], (S000,), (Smax,Smin], (Smin,)
   ; 0:3, net, pos, neg, abs
   
   copy_VarMeta(tmp,Tavg)
   copy_VarMeta(tmp,Savg)
   copy_VarMeta(tmp,Qavg)
   
   Tavg@long_name="Temperature"
   Savg@long_name="Salinity"
   Qavg@long_name="Transport"
   Tavg@units    ="Deg C"
   Savg@units    ="psu"
   Qavg@units    ="Sv"
   
   nc=getenv("fout1")
   system("rm -f "+nc)
   fout  = addfile(nc,"c")
   fout->thetao = Tavg

   nc=getenv("fout2")
   system("rm -f "+nc)
   fout  = addfile(nc,"c")
   fout->so = Savg

   nc=getenv("fout")
   system("rm -f "+nc)
   fout  = addfile(nc,"c")
   fout->trans = Qavg

   delete(Tavg)
   delete(Savg)
   delete(Qavg)
   
print(nc+" Done ")   
